package de.jatitv.commandguiv2.Spigot.cmdManagement.register;

import de.jatitv.commandguiv2.Spigot.Main;
import de.jatitv.commandguiv2.Util;
import net.t2code.lib.Spigot.Lib.messages.send;
import org.bukkit.Bukkit;
import org.bukkit.command.CommandMap;
import org.bukkit.plugin.Plugin;

import java.io.File;
import java.lang.reflect.Field;


public class AliasRegister {
    public static void onRegister() {
        Plugin plugin = Main.getPlugin();
        send.debug(plugin, Bukkit.getServer().getClass().getPackage().getName());
        if (Main.allAliases.toString().equals("[]")) {
            send.console(Util.getPrefix() + " §4No GUI files available");
            return;
        }
        for (String alias : Main.allAliases) {
            if (Main.guiHashMap.get(alias) != null) {
                if (Main.guiHashMap.get(alias).commandAliasEnable) {
                    try {
                        final Field bukkitCommandMap = Bukkit.getServer().getClass().getDeclaredField("commandMap");
                        bukkitCommandMap.setAccessible(true);
                        CommandMap commandMap = (CommandMap) bukkitCommandMap.get(Bukkit.getServer());
                        commandMap.register(alias, new RegisterCommand(alias));
                    } catch(Exception e) {
                        e.printStackTrace();
                    }
                }
            }
        }
    }
}
